struct sDashboardRow
  {
   string            Text;
   color             TextColor;
   string            Font;
   int               size;

   int               Ysize;
   int               YDistance;


  };

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CDashboard
  {

private: //Member Variables

   sDashboardRow     mRows[];
   string            mName;
   int               mYDistance;

private:// Funtions

   string            TextObjectName(int index) {return (StringFormat("%s_%i",mName,index));}
   int               calcRowYDistance(int index);
   void              setRowYDistamce(int index);
   void              DrawRow(int row);
   void              DeleteAll();

public:

   //CDashboard();
                     CDashboard(string name,int yDistance) {Init(name,yDistance);}
                    ~CDashboard() {DeleteAll();}

   void              Init(string name,int yDistance);

public: //CRUD Create,Read,Update,Delete
   //Create - To add new rows at the end
   void              AddRow(string text,color textColor,string font, int size);

   //Read - To get row information
   string            GetRowText(int index)             {return(mRows[index].Text);}
   color             GetRowTextColor(int index)        {return(mRows[index].TextColor);}
   string            GetRowFont(int index)             {return(mRows[index].Font);}
   int               GetRowSize(int index)             {return(mRows[index].size);}
   int               GetRowYDistance(int index)        {return(mRows[index].YDistance);}
   //Update - To Update row text and other information
   void              SetRow(int index,string text,color textcolor,string font, int size);
   void              setRowText(int index,string text);
   //delete - to remove rows
   void              DeleteRows(int first, int last); //detele row and the associated object

public:   //Properties

   string            GetName()  {return(mName);}

   int               GetYDistnace() {return(mYDistance);}
   void              SetYDistance(int value);

  };

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CDashboard::Init(string name,int yDistance)
  {

   mName = name;
   DeleteAll();
   SetYDistance(yDistance);
  }


//+------------------------------------------------------------------+
//General Functions                                                  |
//+------------------------------------------------------------------+
int CDashboard::calcRowYDistance(int index)
  {

   return((index==0)? mYDistance: mRows[index-1].YDistance + mRows[index-1].Ysize + 2); //2 gap between lines
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CDashboard::setRowYDistamce(int index)
  {

//set y distance for all rows starting with 1st
   int yDistance;
   for(int i=index; i<ArraySize(mRows); i++)
     {

      yDistance = calcRowYDistance(i);
      if(yDistance!=mRows[i].YDistance)
        {
         mRows[i].YDistance = yDistance;
         DrawRow(i);
        }
      else
        {
         break;
        }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CDashboard::DrawRow(int index)
  {

   string objectName = TextObjectName(index);
   if(ObjectFind(objectName)<0)
     {

      ObjectCreate(objectName,OBJ_LABEL,0,0,0);
     }
   int currenYSize = mRows[index].Ysize;

   ObjectSetText(objectName,mRows[index].Text,mRows[index].size,mRows[index].Font,mRows[index].TextColor);
   ObjectSet(objectName, OBJPROP_CORNER,1);
   ObjectSet(objectName,OBJPROP_XDISTANCE,8);
   ObjectSet(objectName, OBJPROP_YDISTANCE,mRows[index].YDistance);

   int newYSize  = (int)ObjectGetInteger(0,objectName,OBJPROP_YSIZE);
   if(newYSize>0)
     {
      mRows[index].Ysize = newYSize;
     }
   else
      if(mRows[index].Ysize==0)
        {
         mRows[index].Ysize = mRows[index].size*96/72;
        }
   if(currenYSize!=mRows[index].Ysize)
     {
      setRowYDistamce(index+1);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CDashboard::DeleteAll()
  {
   DeleteRows(0,ArraySize(mRows)-1);
   ObjectsDeleteAll(0,mName+"_");
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CDashboard::AddRow(string text,color textColor,string font,int size)
  {
   int index = ArraySize(mRows);
   ArrayResize(mRows, index+1);

   mRows[index].Text  =text;
   mRows[index].TextColor = textColor;
   mRows[index].Font = font;
   mRows[index].size = size;
   setRowYDistamce(index);

   DrawRow(index);

   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CDashboard::SetRow(int index,string text,color textcolor,string font,int size)
  {

   mRows[index].Text =text;
   mRows[index].TextColor = textcolor;
   mRows[index].Font = font;
   mRows[index].size = size;

   DrawRow(index);

   return;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CDashboard::setRowText(int index,string text)
  {

   mRows[index].Text = text;
   DrawRow(index);

   return;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CDashboard::SetYDistance(int value)
  {

   mYDistance = value;
   setRowYDistamce(0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CDashboard::DeleteRows(int first,int last)
  {

   if(last>=ArraySize(mRows))
      last = ArraySize(mRows)-1;
   if(first<0)
      first= 0;
   if(last<first)
      return;

   sDashboardRow rows[];

   ArrayResize(rows,ArraySize(mRows));
   for(int i =0; i<ArraySize(mRows); i++)
     {

      rows[i] = mRows[i];
     }
   ObjectsDeleteAll(0,mName+"_");
   ArrayResize(mRows,0);

   for(int j = 0; j<ArraySize(rows); j++)
     {

      if(j<first||j>last)
        {

         AddRow(rows[j].Text,rows[j].TextColor,rows[j].Font,rows[j].size);
        }
     }
     return;
  }